package overflow_gateway_websocket

import (
	"time"

	"github.com/valyala/fasthttp"
)

type ServerHandler interface {
	GetHandshakeTimeout() time.Duration
	GetReadBufferSize() int
	GetWriteBufferSize() int
	GetEnableCompression() bool

	OnConnection(ctx *fasthttp.RequestCtx) bool
	OnConnected(soc Socket)
	OnDisconnected(soc Socket)
	OnCheckOrigin(ctx *fasthttp.RequestCtx) bool
	OnError(ctx *fasthttp.RequestCtx, status int, reason error)
	OnIDGenerate(ctx *fasthttp.RequestCtx) string

	Validate()
}
